//========================================================================================
// "    "
//       (FindTextStyle.js)
//
//  1.0
//
//         ,    
//        .   .
//         .
//    
// :   (ragman)
//
// : 26.03.2005 .
//
//=========================================================================================
scriptName = "    ";
scriptVer = " 1.0";
txtFile = "";

//  
function writeFile (myFile, myString) {
	var myResult = myFile.open("w");
	if (!myResult) {
		alert("    !");
		exit();
	}
	myFile.write(myString);
	myFile.close();
}

//   
function fileNameCheck (myFile, myExt) {
	var myPath = myFile.path;
	var myName = myFile.name;
	if (myName.substring((myName.length - myExt.length), ) != myExt) {
		myName +=myExt;
	}
	return new File (myPath + "/" + myName);
}

with (app) {
	
	//     
	myDoc = activeDocument;
	myPageCount = myDoc.pages.length;
	
	//     
	myDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	myDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	
	//  	
	var myStyleNames = new Array();
	for (myCounter = 0; myCounter < myDoc.paragraphStyles.length; myCounter++) {
		myStyleNames[myCounter] = myDoc.paragraphStyles[myCounter].name;
	}

	
//  
	//  
	var myDialog = dialogs.add({name:scriptName + scriptVer});
	// 
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add()) {
			with (dialogColumns.add()) {
				dialogRows.add().staticTexts.add({staticLabel:" :"});
				dialogRows.add().staticTexts.add({staticLabel:" :"});
				dialogRows.add().staticTexts.add({staticLabel:" :"});
			}
			with (dialogColumns.add()) {
				var myDialogPageStart = dialogRows.add().integerEditboxes.add({editValue:1});
				var myDialogPageEnd = dialogRows.add().integerEditboxes.add({editValue:myPageCount});
				var mySelectStyle = dialogRows.add().dropdowns.add({stringList:myStyleNames, selectedIndex:0});
			}
		}
		with (dialogRows.add()) {
			dialogColumns.add().staticTexts.add({staticLabel:"      ragman_mail@front.ru"});
		}
	}
	// 
	var myResult = myDialog.show();
	if (!myResult) {
		myDialog.destroy();
		exit();
	}
	//    
	myPageStart = myDialogPageStart.editContents;
	myPageEnd = myDialogPageEnd.editContents;
	if (myPageEnd < myPageStart) {
		alert ("?");
		exit();

	}
	findParaStyle = myDoc.paragraphStyles[mySelectStyle.selectedIndex].name;
	
	//   
	for (myCount_1 = myPageStart - 1; myCount_1 < myPageEnd; myCount_1++) {
		myPage = myDoc.pages.item(myCount_1);
		//      
		for (myCount_2 = 0; myCount_2 < myPage.textFrames.length; myCount_2++) {
			myTextFrame = myPage.textFrames.item(myCount_2);
			// geometricBounds [y1, x1, y2, x2]
			myFrameLenth = myTextFrame.geometricBounds[2] - myTextFrame.geometricBounds[0];
			myFrameHeight = myTextFrame.geometricBounds[3] - myTextFrame.geometricBounds[1];
			plaseFrame = myFrameLenth * myFrameHeight
			//     
			for (myCount_3 = 0; myCount_3 < myTextFrame.paragraphs.length; myCount_3++) {
				myParagraph = myTextFrame.paragraphs.item(myCount_3);
				//      
				if (myParagraph.appliedParagraphStyle.name == findParaStyle) {
					txtFile = txtFile + "\"" + myParagraph.contents + "\"\n" + " " + (myCount_1 + 1) + "  =" + plaseFrame + ".\n" + "======================\n"
				}
			}
		}
	}
	
	//  
	var myFile = File.saveDialog(scriptName + " " + scriptVer + ".  ", "TXT:*.txt");
	if (!myFile) {
		alert("  !");
		exit();
	}
	myFile = fileNameCheck(myFile, ".txt");
	writeFile(myFile, txtFile);
	alert("  ");
}